/* Software License Agreement (BSD License)
 *
 * Copyright (c) 2011, Willow Garage, Inc.
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 *
 *  * Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 *  * Redistributions in binary form must reproduce the above
 *    copyright notice, this list of conditions and the following
 *    disclaimer in the documentation and/or other materials provided
 *    with the distribution.
 *  * Neither the name of Willow Garage, Inc. nor the names of its
 *    contributors may be used to endorse or promote products derived
 *    from this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
 * "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
 * LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS
 * FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE
 * COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT,
 * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING,
 * BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
 * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER
 * CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN
 * ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
 * POSSIBILITY OF SUCH DAMAGE.
 *
 * Auto-generated by genmsg_cpp from file /tmp/buildd/ros-groovy-jsk-gui-msgs-1.0.40-0quantal-20140920-0114/msg/AndroidSensor.msg
 *
 */


#ifndef JSK_GUI_MSGS_MESSAGE_ANDROIDSENSOR_H
#define JSK_GUI_MSGS_MESSAGE_ANDROIDSENSOR_H


#include <string>
#include <vector>
#include <map>

#include <ros/types.h>
#include <ros/serialization.h>
#include <ros/builtin_message_traits.h>
#include <ros/message_operations.h>


namespace jsk_gui_msgs
{
template <class ContainerAllocator>
struct AndroidSensor_
{
  typedef AndroidSensor_<ContainerAllocator> Type;

  AndroidSensor_()
    : accel_x(0.0)
    , accel_y(0.0)
    , accel_z(0.0)
    , orientation_x(0.0)
    , orientation_y(0.0)
    , orientation_z(0.0)  {
    }
  AndroidSensor_(const ContainerAllocator& _alloc)
    : accel_x(0.0)
    , accel_y(0.0)
    , accel_z(0.0)
    , orientation_x(0.0)
    , orientation_y(0.0)
    , orientation_z(0.0)  {
    }



   typedef double _accel_x_type;
  _accel_x_type accel_x;

   typedef double _accel_y_type;
  _accel_y_type accel_y;

   typedef double _accel_z_type;
  _accel_z_type accel_z;

   typedef double _orientation_x_type;
  _orientation_x_type orientation_x;

   typedef double _orientation_y_type;
  _orientation_y_type orientation_y;

   typedef double _orientation_z_type;
  _orientation_z_type orientation_z;




  typedef boost::shared_ptr< ::jsk_gui_msgs::AndroidSensor_<ContainerAllocator> > Ptr;
  typedef boost::shared_ptr< ::jsk_gui_msgs::AndroidSensor_<ContainerAllocator> const> ConstPtr;
  boost::shared_ptr<std::map<std::string, std::string> > __connection_header;

}; // struct AndroidSensor_

typedef ::jsk_gui_msgs::AndroidSensor_<std::allocator<void> > AndroidSensor;

typedef boost::shared_ptr< ::jsk_gui_msgs::AndroidSensor > AndroidSensorPtr;
typedef boost::shared_ptr< ::jsk_gui_msgs::AndroidSensor const> AndroidSensorConstPtr;

// constants requiring out of line definition



template<typename ContainerAllocator>
std::ostream& operator<<(std::ostream& s, const ::jsk_gui_msgs::AndroidSensor_<ContainerAllocator> & v)
{
ros::message_operations::Printer< ::jsk_gui_msgs::AndroidSensor_<ContainerAllocator> >::stream(s, "", v);
return s;
}

} // namespace jsk_gui_msgs

namespace ros
{
namespace message_traits
{



// BOOLTRAITS {'IsFixedSize': True, 'IsMessage': True, 'HasHeader': False}
// {'sensor_msgs': ['/opt/ros/groovy/share/sensor_msgs/cmake/../msg'], 'jsk_gui_msgs': ['/tmp/buildd/ros-groovy-jsk-gui-msgs-1.0.40-0quantal-20140920-0114/msg'], 'std_msgs': ['/opt/ros/groovy/share/std_msgs/cmake/../msg'], 'geometry_msgs': ['/opt/ros/groovy/share/geometry_msgs/cmake/../msg']}

// !!!!!!!!!!! ['__class__', '__delattr__', '__dict__', '__doc__', '__eq__', '__format__', '__getattribute__', '__hash__', '__init__', '__module__', '__ne__', '__new__', '__reduce__', '__reduce_ex__', '__repr__', '__setattr__', '__sizeof__', '__str__', '__subclasshook__', '__weakref__', '_parsed_fields', 'constants', 'fields', 'full_name', 'has_header', 'header_present', 'names', 'package', 'parsed_fields', 'short_name', 'text', 'types']




template <class ContainerAllocator>
struct IsFixedSize< ::jsk_gui_msgs::AndroidSensor_<ContainerAllocator> >
  : TrueType
  { };

template <class ContainerAllocator>
struct IsFixedSize< ::jsk_gui_msgs::AndroidSensor_<ContainerAllocator> const>
  : TrueType
  { };

template <class ContainerAllocator>
struct IsMessage< ::jsk_gui_msgs::AndroidSensor_<ContainerAllocator> >
  : TrueType
  { };

template <class ContainerAllocator>
struct IsMessage< ::jsk_gui_msgs::AndroidSensor_<ContainerAllocator> const>
  : TrueType
  { };

template <class ContainerAllocator>
struct HasHeader< ::jsk_gui_msgs::AndroidSensor_<ContainerAllocator> >
  : FalseType
  { };

template <class ContainerAllocator>
struct HasHeader< ::jsk_gui_msgs::AndroidSensor_<ContainerAllocator> const>
  : FalseType
  { };


template<class ContainerAllocator>
struct MD5Sum< ::jsk_gui_msgs::AndroidSensor_<ContainerAllocator> >
{
  static const char* value()
  {
    return "d832dbe3be7e7f061d963f2188f1a407";
  }

  static const char* value(const ::jsk_gui_msgs::AndroidSensor_<ContainerAllocator>&) { return value(); }
  static const uint64_t static_value1 = 0xd832dbe3be7e7f06ULL;
  static const uint64_t static_value2 = 0x1d963f2188f1a407ULL;
};

template<class ContainerAllocator>
struct DataType< ::jsk_gui_msgs::AndroidSensor_<ContainerAllocator> >
{
  static const char* value()
  {
    return "jsk_gui_msgs/AndroidSensor";
  }

  static const char* value(const ::jsk_gui_msgs::AndroidSensor_<ContainerAllocator>&) { return value(); }
};

template<class ContainerAllocator>
struct Definition< ::jsk_gui_msgs::AndroidSensor_<ContainerAllocator> >
{
  static const char* value()
  {
    return "# sonsor for Tablet\n\
float64 accel_x\n\
float64 accel_y\n\
float64 accel_z\n\
float64 orientation_x\n\
float64 orientation_y\n\
float64 orientation_z\n\
\n\
\n\
";
  }

  static const char* value(const ::jsk_gui_msgs::AndroidSensor_<ContainerAllocator>&) { return value(); }
};

} // namespace message_traits
} // namespace ros

namespace ros
{
namespace serialization
{

  template<class ContainerAllocator> struct Serializer< ::jsk_gui_msgs::AndroidSensor_<ContainerAllocator> >
  {
    template<typename Stream, typename T> inline static void allInOne(Stream& stream, T m)
    {
      stream.next(m.accel_x);
      stream.next(m.accel_y);
      stream.next(m.accel_z);
      stream.next(m.orientation_x);
      stream.next(m.orientation_y);
      stream.next(m.orientation_z);
    }

    ROS_DECLARE_ALLINONE_SERIALIZER;
  }; // struct AndroidSensor_

} // namespace serialization
} // namespace ros

namespace ros
{
namespace message_operations
{

template<class ContainerAllocator>
struct Printer< ::jsk_gui_msgs::AndroidSensor_<ContainerAllocator> >
{
  template<typename Stream> static void stream(Stream& s, const std::string& indent, const ::jsk_gui_msgs::AndroidSensor_<ContainerAllocator>& v)
  {
    s << indent << "accel_x: ";
    Printer<double>::stream(s, indent + "  ", v.accel_x);
    s << indent << "accel_y: ";
    Printer<double>::stream(s, indent + "  ", v.accel_y);
    s << indent << "accel_z: ";
    Printer<double>::stream(s, indent + "  ", v.accel_z);
    s << indent << "orientation_x: ";
    Printer<double>::stream(s, indent + "  ", v.orientation_x);
    s << indent << "orientation_y: ";
    Printer<double>::stream(s, indent + "  ", v.orientation_y);
    s << indent << "orientation_z: ";
    Printer<double>::stream(s, indent + "  ", v.orientation_z);
  }
};

} // namespace message_operations
} // namespace ros

#endif // JSK_GUI_MSGS_MESSAGE_ANDROIDSENSOR_H
