/* Software License Agreement (BSD License)
 *
 * Copyright (c) 2011, Willow Garage, Inc.
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 *
 *  * Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 *  * Redistributions in binary form must reproduce the above
 *    copyright notice, this list of conditions and the following
 *    disclaimer in the documentation and/or other materials provided
 *    with the distribution.
 *  * Neither the name of Willow Garage, Inc. nor the names of its
 *    contributors may be used to endorse or promote products derived
 *    from this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
 * "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
 * LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS
 * FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE
 * COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT,
 * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING,
 * BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
 * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER
 * CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN
 * ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
 * POSSIBILITY OF SUCH DAMAGE.
 *
 * Auto-generated by genmsg_cpp from file /tmp/buildd/ros-groovy-jsk-gui-msgs-1.0.40-0quantal-20140920-0114/msg/DeviceSensorALL.msg
 *
 */


#ifndef JSK_GUI_MSGS_MESSAGE_DEVICESENSORALL_H
#define JSK_GUI_MSGS_MESSAGE_DEVICESENSORALL_H


#include <string>
#include <vector>
#include <map>

#include <ros/types.h>
#include <ros/serialization.h>
#include <ros/builtin_message_traits.h>
#include <ros/message_operations.h>


namespace jsk_gui_msgs
{
template <class ContainerAllocator>
struct DeviceSensorALL_
{
  typedef DeviceSensorALL_<ContainerAllocator> Type;

  DeviceSensorALL_()
    : accelerometer_x(0.0)
    , accelerometer_y(0.0)
    , accelerometer_z(0.0)
    , magneticfield_x(0.0)
    , magneticfield_y(0.0)
    , magneticfield_z(0.0)
    , gyroscope_x(0.0)
    , gyroscope_y(0.0)
    , gyroscope_z(0.0)
    , light(0.0)
    , pressure(0.0)
    , proximity(false)
    , gravity_x(0.0)
    , gravity_y(0.0)
    , gravity_z(0.0)
    , linear_acceleration_x(0.0)
    , linear_acceleration_y(0.0)
    , linear_acceleration_z(0.0)
    , rotation_vector_x(0.0)
    , rotation_vector_y(0.0)
    , rotation_vector_z(0.0)
    , rotation_vector_optional(0.0)
    , orientation_x(0.0)
    , orientation_y(0.0)
    , orientation_z(0.0)
    , relative_humidity(0.0)
    , temperature(0.0)
    , ambient_temperature(0.0)  {
    }
  DeviceSensorALL_(const ContainerAllocator& _alloc)
    : accelerometer_x(0.0)
    , accelerometer_y(0.0)
    , accelerometer_z(0.0)
    , magneticfield_x(0.0)
    , magneticfield_y(0.0)
    , magneticfield_z(0.0)
    , gyroscope_x(0.0)
    , gyroscope_y(0.0)
    , gyroscope_z(0.0)
    , light(0.0)
    , pressure(0.0)
    , proximity(false)
    , gravity_x(0.0)
    , gravity_y(0.0)
    , gravity_z(0.0)
    , linear_acceleration_x(0.0)
    , linear_acceleration_y(0.0)
    , linear_acceleration_z(0.0)
    , rotation_vector_x(0.0)
    , rotation_vector_y(0.0)
    , rotation_vector_z(0.0)
    , rotation_vector_optional(0.0)
    , orientation_x(0.0)
    , orientation_y(0.0)
    , orientation_z(0.0)
    , relative_humidity(0.0)
    , temperature(0.0)
    , ambient_temperature(0.0)  {
    }



   typedef double _accelerometer_x_type;
  _accelerometer_x_type accelerometer_x;

   typedef double _accelerometer_y_type;
  _accelerometer_y_type accelerometer_y;

   typedef double _accelerometer_z_type;
  _accelerometer_z_type accelerometer_z;

   typedef double _magneticfield_x_type;
  _magneticfield_x_type magneticfield_x;

   typedef double _magneticfield_y_type;
  _magneticfield_y_type magneticfield_y;

   typedef double _magneticfield_z_type;
  _magneticfield_z_type magneticfield_z;

   typedef double _gyroscope_x_type;
  _gyroscope_x_type gyroscope_x;

   typedef double _gyroscope_y_type;
  _gyroscope_y_type gyroscope_y;

   typedef double _gyroscope_z_type;
  _gyroscope_z_type gyroscope_z;

   typedef double _light_type;
  _light_type light;

   typedef double _pressure_type;
  _pressure_type pressure;

   typedef uint8_t _proximity_type;
  _proximity_type proximity;

   typedef double _gravity_x_type;
  _gravity_x_type gravity_x;

   typedef double _gravity_y_type;
  _gravity_y_type gravity_y;

   typedef double _gravity_z_type;
  _gravity_z_type gravity_z;

   typedef double _linear_acceleration_x_type;
  _linear_acceleration_x_type linear_acceleration_x;

   typedef double _linear_acceleration_y_type;
  _linear_acceleration_y_type linear_acceleration_y;

   typedef double _linear_acceleration_z_type;
  _linear_acceleration_z_type linear_acceleration_z;

   typedef double _rotation_vector_x_type;
  _rotation_vector_x_type rotation_vector_x;

   typedef double _rotation_vector_y_type;
  _rotation_vector_y_type rotation_vector_y;

   typedef double _rotation_vector_z_type;
  _rotation_vector_z_type rotation_vector_z;

   typedef double _rotation_vector_optional_type;
  _rotation_vector_optional_type rotation_vector_optional;

   typedef double _orientation_x_type;
  _orientation_x_type orientation_x;

   typedef double _orientation_y_type;
  _orientation_y_type orientation_y;

   typedef double _orientation_z_type;
  _orientation_z_type orientation_z;

   typedef double _relative_humidity_type;
  _relative_humidity_type relative_humidity;

   typedef double _temperature_type;
  _temperature_type temperature;

   typedef double _ambient_temperature_type;
  _ambient_temperature_type ambient_temperature;




  typedef boost::shared_ptr< ::jsk_gui_msgs::DeviceSensorALL_<ContainerAllocator> > Ptr;
  typedef boost::shared_ptr< ::jsk_gui_msgs::DeviceSensorALL_<ContainerAllocator> const> ConstPtr;
  boost::shared_ptr<std::map<std::string, std::string> > __connection_header;

}; // struct DeviceSensorALL_

typedef ::jsk_gui_msgs::DeviceSensorALL_<std::allocator<void> > DeviceSensorALL;

typedef boost::shared_ptr< ::jsk_gui_msgs::DeviceSensorALL > DeviceSensorALLPtr;
typedef boost::shared_ptr< ::jsk_gui_msgs::DeviceSensorALL const> DeviceSensorALLConstPtr;

// constants requiring out of line definition



template<typename ContainerAllocator>
std::ostream& operator<<(std::ostream& s, const ::jsk_gui_msgs::DeviceSensorALL_<ContainerAllocator> & v)
{
ros::message_operations::Printer< ::jsk_gui_msgs::DeviceSensorALL_<ContainerAllocator> >::stream(s, "", v);
return s;
}

} // namespace jsk_gui_msgs

namespace ros
{
namespace message_traits
{



// BOOLTRAITS {'IsFixedSize': True, 'IsMessage': True, 'HasHeader': False}
// {'sensor_msgs': ['/opt/ros/groovy/share/sensor_msgs/cmake/../msg'], 'jsk_gui_msgs': ['/tmp/buildd/ros-groovy-jsk-gui-msgs-1.0.40-0quantal-20140920-0114/msg'], 'std_msgs': ['/opt/ros/groovy/share/std_msgs/cmake/../msg'], 'geometry_msgs': ['/opt/ros/groovy/share/geometry_msgs/cmake/../msg']}

// !!!!!!!!!!! ['__class__', '__delattr__', '__dict__', '__doc__', '__eq__', '__format__', '__getattribute__', '__hash__', '__init__', '__module__', '__ne__', '__new__', '__reduce__', '__reduce_ex__', '__repr__', '__setattr__', '__sizeof__', '__str__', '__subclasshook__', '__weakref__', '_parsed_fields', 'constants', 'fields', 'full_name', 'has_header', 'header_present', 'names', 'package', 'parsed_fields', 'short_name', 'text', 'types']




template <class ContainerAllocator>
struct IsFixedSize< ::jsk_gui_msgs::DeviceSensorALL_<ContainerAllocator> >
  : TrueType
  { };

template <class ContainerAllocator>
struct IsFixedSize< ::jsk_gui_msgs::DeviceSensorALL_<ContainerAllocator> const>
  : TrueType
  { };

template <class ContainerAllocator>
struct IsMessage< ::jsk_gui_msgs::DeviceSensorALL_<ContainerAllocator> >
  : TrueType
  { };

template <class ContainerAllocator>
struct IsMessage< ::jsk_gui_msgs::DeviceSensorALL_<ContainerAllocator> const>
  : TrueType
  { };

template <class ContainerAllocator>
struct HasHeader< ::jsk_gui_msgs::DeviceSensorALL_<ContainerAllocator> >
  : FalseType
  { };

template <class ContainerAllocator>
struct HasHeader< ::jsk_gui_msgs::DeviceSensorALL_<ContainerAllocator> const>
  : FalseType
  { };


template<class ContainerAllocator>
struct MD5Sum< ::jsk_gui_msgs::DeviceSensorALL_<ContainerAllocator> >
{
  static const char* value()
  {
    return "c6760fdd899a253540b8dfd19f6a9ed4";
  }

  static const char* value(const ::jsk_gui_msgs::DeviceSensorALL_<ContainerAllocator>&) { return value(); }
  static const uint64_t static_value1 = 0xc6760fdd899a2535ULL;
  static const uint64_t static_value2 = 0x40b8dfd19f6a9ed4ULL;
};

template<class ContainerAllocator>
struct DataType< ::jsk_gui_msgs::DeviceSensorALL_<ContainerAllocator> >
{
  static const char* value()
  {
    return "jsk_gui_msgs/DeviceSensorALL";
  }

  static const char* value(const ::jsk_gui_msgs::DeviceSensorALL_<ContainerAllocator>&) { return value(); }
};

template<class ContainerAllocator>
struct Definition< ::jsk_gui_msgs::DeviceSensorALL_<ContainerAllocator> >
{
  static const char* value()
  {
    return "# sensor for Tablet\n\
\n\
float64 accelerometer_x\n\
float64 accelerometer_y\n\
float64 accelerometer_z\n\
\n\
float64 magneticfield_x\n\
float64 magneticfield_y\n\
float64 magneticfield_z\n\
\n\
float64 gyroscope_x\n\
float64 gyroscope_y\n\
float64 gyroscope_z\n\
\n\
float64 light\n\
\n\
float64 pressure\n\
\n\
bool proximity\n\
\n\
float64 gravity_x\n\
float64 gravity_y\n\
float64 gravity_z\n\
\n\
float64 linear_acceleration_x\n\
float64 linear_acceleration_y\n\
float64 linear_acceleration_z\n\
\n\
float64 rotation_vector_x\n\
float64 rotation_vector_y\n\
float64 rotation_vector_z\n\
float64 rotation_vector_optional\n\
\n\
float64 orientation_x\n\
float64 orientation_y\n\
float64 orientation_z\n\
\n\
float64 relative_humidity\n\
\n\
float64 temperature\n\
\n\
float64 ambient_temperature\n\
\n\
\n\
\n\
\n\
\n\
";
  }

  static const char* value(const ::jsk_gui_msgs::DeviceSensorALL_<ContainerAllocator>&) { return value(); }
};

} // namespace message_traits
} // namespace ros

namespace ros
{
namespace serialization
{

  template<class ContainerAllocator> struct Serializer< ::jsk_gui_msgs::DeviceSensorALL_<ContainerAllocator> >
  {
    template<typename Stream, typename T> inline static void allInOne(Stream& stream, T m)
    {
      stream.next(m.accelerometer_x);
      stream.next(m.accelerometer_y);
      stream.next(m.accelerometer_z);
      stream.next(m.magneticfield_x);
      stream.next(m.magneticfield_y);
      stream.next(m.magneticfield_z);
      stream.next(m.gyroscope_x);
      stream.next(m.gyroscope_y);
      stream.next(m.gyroscope_z);
      stream.next(m.light);
      stream.next(m.pressure);
      stream.next(m.proximity);
      stream.next(m.gravity_x);
      stream.next(m.gravity_y);
      stream.next(m.gravity_z);
      stream.next(m.linear_acceleration_x);
      stream.next(m.linear_acceleration_y);
      stream.next(m.linear_acceleration_z);
      stream.next(m.rotation_vector_x);
      stream.next(m.rotation_vector_y);
      stream.next(m.rotation_vector_z);
      stream.next(m.rotation_vector_optional);
      stream.next(m.orientation_x);
      stream.next(m.orientation_y);
      stream.next(m.orientation_z);
      stream.next(m.relative_humidity);
      stream.next(m.temperature);
      stream.next(m.ambient_temperature);
    }

    ROS_DECLARE_ALLINONE_SERIALIZER;
  }; // struct DeviceSensorALL_

} // namespace serialization
} // namespace ros

namespace ros
{
namespace message_operations
{

template<class ContainerAllocator>
struct Printer< ::jsk_gui_msgs::DeviceSensorALL_<ContainerAllocator> >
{
  template<typename Stream> static void stream(Stream& s, const std::string& indent, const ::jsk_gui_msgs::DeviceSensorALL_<ContainerAllocator>& v)
  {
    s << indent << "accelerometer_x: ";
    Printer<double>::stream(s, indent + "  ", v.accelerometer_x);
    s << indent << "accelerometer_y: ";
    Printer<double>::stream(s, indent + "  ", v.accelerometer_y);
    s << indent << "accelerometer_z: ";
    Printer<double>::stream(s, indent + "  ", v.accelerometer_z);
    s << indent << "magneticfield_x: ";
    Printer<double>::stream(s, indent + "  ", v.magneticfield_x);
    s << indent << "magneticfield_y: ";
    Printer<double>::stream(s, indent + "  ", v.magneticfield_y);
    s << indent << "magneticfield_z: ";
    Printer<double>::stream(s, indent + "  ", v.magneticfield_z);
    s << indent << "gyroscope_x: ";
    Printer<double>::stream(s, indent + "  ", v.gyroscope_x);
    s << indent << "gyroscope_y: ";
    Printer<double>::stream(s, indent + "  ", v.gyroscope_y);
    s << indent << "gyroscope_z: ";
    Printer<double>::stream(s, indent + "  ", v.gyroscope_z);
    s << indent << "light: ";
    Printer<double>::stream(s, indent + "  ", v.light);
    s << indent << "pressure: ";
    Printer<double>::stream(s, indent + "  ", v.pressure);
    s << indent << "proximity: ";
    Printer<uint8_t>::stream(s, indent + "  ", v.proximity);
    s << indent << "gravity_x: ";
    Printer<double>::stream(s, indent + "  ", v.gravity_x);
    s << indent << "gravity_y: ";
    Printer<double>::stream(s, indent + "  ", v.gravity_y);
    s << indent << "gravity_z: ";
    Printer<double>::stream(s, indent + "  ", v.gravity_z);
    s << indent << "linear_acceleration_x: ";
    Printer<double>::stream(s, indent + "  ", v.linear_acceleration_x);
    s << indent << "linear_acceleration_y: ";
    Printer<double>::stream(s, indent + "  ", v.linear_acceleration_y);
    s << indent << "linear_acceleration_z: ";
    Printer<double>::stream(s, indent + "  ", v.linear_acceleration_z);
    s << indent << "rotation_vector_x: ";
    Printer<double>::stream(s, indent + "  ", v.rotation_vector_x);
    s << indent << "rotation_vector_y: ";
    Printer<double>::stream(s, indent + "  ", v.rotation_vector_y);
    s << indent << "rotation_vector_z: ";
    Printer<double>::stream(s, indent + "  ", v.rotation_vector_z);
    s << indent << "rotation_vector_optional: ";
    Printer<double>::stream(s, indent + "  ", v.rotation_vector_optional);
    s << indent << "orientation_x: ";
    Printer<double>::stream(s, indent + "  ", v.orientation_x);
    s << indent << "orientation_y: ";
    Printer<double>::stream(s, indent + "  ", v.orientation_y);
    s << indent << "orientation_z: ";
    Printer<double>::stream(s, indent + "  ", v.orientation_z);
    s << indent << "relative_humidity: ";
    Printer<double>::stream(s, indent + "  ", v.relative_humidity);
    s << indent << "temperature: ";
    Printer<double>::stream(s, indent + "  ", v.temperature);
    s << indent << "ambient_temperature: ";
    Printer<double>::stream(s, indent + "  ", v.ambient_temperature);
  }
};

} // namespace message_operations
} // namespace ros

#endif // JSK_GUI_MSGS_MESSAGE_DEVICESENSORALL_H
